"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManyGsiTable = exports.NoGsiTable = exports.DocumentClient = exports.Client = exports.TABLE_NAME = void 0;
const client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
const lib_dynamodb_1 = require("@aws-sdk/lib-dynamodb");
const Table_1 = require("./Table");
exports.TABLE_NAME = process.env.DYNAMODB_TABLE || 'test';
exports.Client = process.env.INTEGRATION_TEST === 'true'
    ? new client_dynamodb_1.DynamoDB({})
    : new client_dynamodb_1.DynamoDB({
        endpoint: 'http://127.0.0.1:8000',
        region: 'local-env',
        credentials: {
            accessKeyId: 'fakeMyKeyId',
            secretAccessKey: 'fakeSecretAccessKey'
        }
    });
exports.DocumentClient = lib_dynamodb_1.DynamoDBDocumentClient.from(exports.Client);
exports.NoGsiTable = new Table_1.Table({
    client: exports.DocumentClient,
    name: exports.TABLE_NAME,
    indexes: {
        primaryIndex: {
            hash: {
                key: 'pk',
                value: 'string'
            },
            sort: {
                key: 'sk',
                value: 'string'
            }
        }
    }
});
exports.ManyGsiTable = new Table_1.Table({
    client: exports.DocumentClient,
    name: exports.TABLE_NAME,
    indexes: {
        primaryIndex: {
            hash: {
                key: 'pk',
                value: 'string'
            },
            sort: {
                key: 'sk',
                value: 'string'
            }
        },
        gsi0: {
            hash: {
                key: 'gsi0Pk',
                value: 'string'
            },
            sort: {
                key: 'gsi0Sk',
                value: 'string'
            }
        },
        gsi1: {
            hash: {
                key: 'gsi1Pk',
                value: 'number'
            },
            sort: {
                key: 'gsi1Sk',
                value: 'number?'
            },
            projection: []
        },
        gsi2: {
            hash: {
                key: 'gsi2Pk',
                value: 'string'
            },
            sort: {
                key: 'gsi2Sk',
                value: 'number'
            },
            projection: ['string']
        },
        gsi3: {
            hash: {
                key: 'gsi3Pk',
                value: 'number'
            },
            sort: {
                key: 'gsi3Sk',
                value: 'string?'
            }
        },
        gsi4: {
            hash: {
                key: 'gsi4Pk',
                value: 'string'
            }
        },
        gsi5: {
            hash: {
                key: 'gsi5Pk',
                value: 'number'
            }
        }
    }
});
