"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamoDBKeySpaceStage = void 0;
const aws_cdk_lib_1 = require("aws-cdk-lib");
const App_1 = require("./App");
const Stack_1 = require("./Stack");
class DynamoDBKeySpaceStage extends aws_cdk_lib_1.Stage {
    constructor(scope, id, props) {
        super(scope, id, props);
        const deploymentName = `${App_1.serviceName}-${props.stage}`;
        const stack = new Stack_1.DynamoDBKeySpaceStack(this, `${deploymentName}-stack`, {
            stage: props.stage,
            deploymentName,
            env: {
                region: process.env.CDK_DEFAULT_REGION,
                account: process.env.CDK_DEFAULT_ACCOUNT
            }
        });
        this.tableName = stack.tableName;
        this.scanTableName = stack.scanTableName;
        this.resetTableName = stack.resetTableName;
    }
}
exports.DynamoDBKeySpaceStage = DynamoDBKeySpaceStage;
