"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createItem = exports.createTableItem = void 0;
const put_1 = require("./put");
const createTableItem = async (Table, item, input, dkClient = Table.dkClient) => {
    await (0, put_1.putTableItem)(Table, item, {
        ...input,
        conditionExpression: `attribute_not_exists(#hashKey)${(input === null || input === void 0 ? void 0 : input.conditionExpression) ? ` ${input === null || input === void 0 ? void 0 : input.conditionExpression}` : ''}`,
        expressionAttributeNames: {
            '#hashKey': Table.config.indexes.primaryIndex.hash.key,
            ...input === null || input === void 0 ? void 0 : input.expressionAttributeNames
        }
    }, dkClient);
    return;
};
exports.createTableItem = createTableItem;
const createItem = async (KeySpace, item, input) => (0, exports.createTableItem)(KeySpace.Table, KeySpace.withIndexKeys(item), input, KeySpace.dkClient);
exports.createItem = createItem;
