"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteItem = exports.deleteTableItem = void 0;
const Delete_1 = require("../command/Delete");
const deleteTableItem = async (Table, key, input, dkClient = Table.dkClient) => {
    const output = await dkClient.send(new Delete_1.DkDeleteCommand({
        ...input,
        tableName: Table.tableName,
        key
    }));
    return output.attributes;
};
exports.deleteTableItem = deleteTableItem;
const deleteItem = async (KeySpace, keyParams, input) => {
    const attributes = await (0, exports.deleteTableItem)(KeySpace.Table, KeySpace.keyOf(keyParams), input, KeySpace.dkClient);
    const strippedAttributes = (attributes ? KeySpace.omitIndexKeys(attributes) : undefined);
    return strippedAttributes;
};
exports.deleteItem = deleteItem;
