"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getItem = exports.getTableItem = void 0;
const Get_1 = require("../command/Get");
const getTableItem = async (Table, key, input, dkClient = Table.dkClient) => {
    const output = await dkClient.send(new Get_1.DkGetCommand({
        ...input,
        tableName: Table.tableName,
        key: key
    }));
    return output.item;
};
exports.getTableItem = getTableItem;
const getItem = async (KeySpace, keyParams, input) => {
    const item = await (0, exports.getTableItem)(KeySpace.Table, KeySpace.keyOf(keyParams), input, KeySpace.dkClient);
    KeySpace.assertAttributesAndKeys(item);
    return KeySpace.omitIndexKeys(item);
};
exports.getItem = getItem;
