"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.putItem = exports.putTableItem = void 0;
const Put_1 = require("../command/Put");
const putTableItem = async (Table, item, input, dkClient = Table.dkClient) => {
    const output = await dkClient.send(new Put_1.DkPutCommand({
        ...input,
        tableName: Table.tableName,
        item
    }));
    return output.attributes;
};
exports.putTableItem = putTableItem;
const putItem = async (KeySpace, item, input) => {
    const attributes = await (0, exports.putTableItem)(KeySpace.Table, KeySpace.withIndexKeys(item), input, KeySpace.dkClient);
    const strippedAttributes = (attributes ? KeySpace.omitIndexKeys(attributes) : undefined);
    return strippedAttributes;
};
exports.putItem = putItem;
