"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.queryGetItem = exports.queryGetTableItem = void 0;
const query_1 = require("./query");
const Table_1 = require("../Table");
const queryGetTableItem = async (Table, index, key, input, dkClient = Table.dkClient) => {
    const setIndex = index !== Table_1.primaryIndex ? index : undefined;
    const keyEntries = Object.entries(key);
    const output = await (0, query_1.queryTableItems)(Table, {
        ...input,
        index: setIndex,
        pageLimit: 1,
        keyConditionExpression: keyEntries.map(([key]) => `${key} = :${key}`).join(' AND '),
        expressionAttributeValues: {
            ...Object.fromEntries(keyEntries.map(([key, value]) => [`:${key}`, value])),
            ...input === null || input === void 0 ? void 0 : input.expressionAttributeValues
        }
    }, dkClient);
    if (!output.items[0])
        throw new Error('Not Found');
    return output.items[0];
};
exports.queryGetTableItem = queryGetTableItem;
const queryGetItem = async (KeySpace, index, keyParams, input) => {
    const item = await (0, exports.queryGetTableItem)(KeySpace.Table, index, KeySpace.indexKeyOf(index, keyParams), input, KeySpace.dkClient);
    KeySpace.assertAttributesAndKeys(item);
    return KeySpace.omitIndexKeys(item);
};
exports.queryGetItem = queryGetItem;
