"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resetTableItems = void 0;
const scan_1 = require("./scan");
const batchWrite_1 = require("./batchWrite");
const resetTableItems = async (Table) => {
    const scanData = await (0, scan_1.scanTableItems)(Table, undefined);
    if (scanData.items.length === 0)
        return;
    await (0, batchWrite_1.batchWriteTableItems)(Table, scanData.items.map(item => ({
        delete: Table.pickPrimaryIndexKey(item)
    })), undefined);
    return;
};
exports.resetTableItems = resetTableItems;
