"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transactGetItems = exports.transactGetTableItems = void 0;
const TransactGet_1 = require("../command/TransactGet");
const transactGetTableItems = async (Table, keys, input, dkClient = Table.dkClient) => {
    const output = await dkClient.send(new TransactGet_1.DkTransactGetCommand({
        ...input,
        requests: keys.map(key => ({ tableName: Table.tableName, key }))
    }));
    return output.items;
};
exports.transactGetTableItems = transactGetTableItems;
const transactGetItems = async (KeySpace, keyParams, input) => {
    const items = await (0, exports.transactGetTableItems)(KeySpace.Table, keyParams.map(kp => KeySpace.keyOf(kp), input), input, KeySpace.dkClient);
    return items.map(item => {
        KeySpace.assertAttributesAndKeys(item);
        return KeySpace.omitIndexKeys(item);
    });
};
exports.transactGetItems = transactGetItems;
