"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transactWriteItems = exports.transactWriteTableItems = void 0;
const TransactWrite_1 = require("../command/TransactWrite");
const transactWriteTableItems = async (Table, requests, input, dkClient = Table.dkClient) => dkClient.send(new TransactWrite_1.DkTransactWriteCommand({
    ...input,
    requests: requests.map(request => ({ ...request, tableName: Table.tableName }))
}));
exports.transactWriteTableItems = transactWriteTableItems;
const transactWriteItems = async (KeySpace, requests, input) => (0, exports.transactWriteTableItems)(KeySpace.Table, requests.map(request => {
    if (request.type === 'put') {
        return {
            ...request,
            item: KeySpace.withIndexKeys(request.item)
        };
    }
    return {
        ...request,
        key: KeySpace.keyOf(request.key)
    };
}), input, KeySpace.dkClient);
exports.transactWriteItems = transactWriteItems;
