"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateItem = exports.updateTableItem = void 0;
const client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
const Update_1 = require("../command/Update");
const updateTableItem = async (Table, key, input, dkClient = Table.dkClient) => {
    const output = await dkClient.send(new Update_1.DkUpdateCommand({
        ...input,
        tableName: Table.tableName,
        key,
        returnValues: (input.returnValues || client_dynamodb_1.ReturnValue.ALL_NEW)
    }));
    return output.attributes;
};
exports.updateTableItem = updateTableItem;
const updateItem = async (KeySpace, keyParams, input) => {
    const attributes = await (0, exports.updateTableItem)(KeySpace.Table, KeySpace.keyOf(keyParams), input, KeySpace.dkClient);
    const strippedAttributes = (attributes ? KeySpace.omitIndexKeys(attributes) : undefined);
    return strippedAttributes;
};
exports.updateItem = updateItem;
