"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateQuickItem = exports.updateQuickTableItem = void 0;
const convertObjectToUpdateExpression_1 = require("../util/convertObjectToUpdateExpression");
const update_1 = require("./update");
const updateQuickTableItem = async (Table, key, updateAttributes, input, dkClient = Table.dkClient) => {
    const updateExpressionParams = (0, convertObjectToUpdateExpression_1.convertObjectToUpdateExpression)(updateAttributes);
    const attributes = await (0, update_1.updateTableItem)(Table, key, {
        ...input,
        ...updateExpressionParams,
        expressionAttributeNames: {
            ...updateExpressionParams.expressionAttributeNames,
            ...input === null || input === void 0 ? void 0 : input.expressionAttributeNames
        },
        expressionAttributeValues: {
            ...updateExpressionParams.expressionAttributeValues,
            ...input === null || input === void 0 ? void 0 : input.expressionAttributeValues
        }
    }, dkClient);
    return attributes;
};
exports.updateQuickTableItem = updateQuickTableItem;
const updateQuickItem = async (KeySpace, keyParams, updateAttributes, input) => {
    const attributes = await (0, exports.updateQuickTableItem)(KeySpace.Table, KeySpace.keyOf(keyParams), updateAttributes, input, KeySpace.dkClient);
    const strippedAttributes = (attributes ? KeySpace.omitIndexKeys(attributes) : undefined);
    return strippedAttributes;
};
exports.updateQuickItem = updateQuickItem;
