"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayOfLength = exports.run = exports.randomString = exports.randomNumber = exports.hash = exports.zipObject = void 0;
const crypto_1 = require("crypto");
const zipObject = (keys, values) => {
    return Object.fromEntries(keys.map((k, i) => [k, values[i]]));
};
exports.zipObject = zipObject;
const hash = (values, size = 21) => {
    const hash = (0, crypto_1.createHash)('sha256');
    for (const value of values) {
        hash.update(value);
    }
    const hashValue = hash.end().read();
    return hashValue.toString('base64url').split('-').join('').split('_').join('').slice(0, size) || '';
};
exports.hash = hash;
const randomNumber = () => Math.round(Math.random() * Number.MAX_SAFE_INTEGER);
exports.randomNumber = randomNumber;
const randomString = (size) => (0, exports.hash)([(0, exports.randomNumber)().toString()], size);
exports.randomString = randomString;
const run = (fn) => fn();
exports.run = run;
const arrayOfLength = (length) => Array.apply(null, Array(Math.max(Math.round(length), 0))).map(() => { });
exports.arrayOfLength = arrayOfLength;
