export const executeMiddleware = async (hook, params, middleware) => {
    const recurse = async (currentParams, remainingMiddleware) => {
        if (remainingMiddleware.length === 0)
            return currentParams;
        const middleware = remainingMiddleware[0];
        const nextMiddlewares = remainingMiddleware.slice(1);
        if (middleware.hook !== hook)
            return recurse(currentParams, nextMiddlewares);
        const output = await middleware.handler(currentParams);
        const newParams = {
            dataType: currentParams.dataType,
            data: output || currentParams.data
        };
        return recurse(newParams, nextMiddlewares);
    };
    return recurse(params, middleware);
};
export const executeMiddlewares = async (hooks, params, middleware) => {
    const recurse = async (currentParams, remainingHooks) => {
        if (remainingHooks.length === 0)
            return currentParams;
        const hook = remainingHooks[0];
        const nextHooks = remainingHooks.slice(1);
        const newParams = await executeMiddleware(hook, currentParams, middleware);
        return recurse(newParams, nextHooks);
    };
    return recurse(params, hooks);
};
export const appendMiddleware = (middlewares1, middlewares2) => [...middlewares1, ...middlewares2];
