import { Stage } from 'aws-cdk-lib';
import { serviceName } from './App';
import { DynamoDBKeySpaceStack } from './Stack';
export class DynamoDBKeySpaceStage extends Stage {
    constructor(scope, id, props) {
        super(scope, id, props);
        const deploymentName = `${serviceName}-${props.stage}`;
        const stack = new DynamoDBKeySpaceStack(this, `${deploymentName}-stack`, {
            stage: props.stage,
            deploymentName,
            env: {
                region: process.env.CDK_DEFAULT_REGION,
                account: process.env.CDK_DEFAULT_ACCOUNT
            }
        });
        this.tableName = stack.tableName;
        this.scanTableName = stack.scanTableName;
        this.resetTableName = stack.resetTableName;
    }
}
