import { DkTransactGetCommand } from '../command/TransactGet';
export const transactGetTableItems = async (Table, keys, input, dkClient = Table.dkClient) => {
    const output = await dkClient.send(new DkTransactGetCommand({
        ...input,
        requests: keys.map(key => ({ tableName: Table.tableName, key }))
    }));
    return output.items;
};
export const transactGetItems = async (KeySpace, keyParams, input) => {
    const items = await transactGetTableItems(KeySpace.Table, keyParams.map(kp => KeySpace.keyOf(kp), input), input, KeySpace.dkClient);
    return items.map(item => {
        KeySpace.assertAttributesAndKeys(item);
        return KeySpace.omitIndexKeys(item);
    });
};
