import { DkTransactWriteCommand } from '../command/TransactWrite';
export const transactWriteTableItems = async (Table, requests, input, dkClient = Table.dkClient) => dkClient.send(new DkTransactWriteCommand({
    ...input,
    requests: requests.map(request => ({ ...request, tableName: Table.tableName }))
}));
export const transactWriteItems = async (KeySpace, requests, input) => transactWriteTableItems(KeySpace.Table, requests.map(request => {
    if (request.type === 'put') {
        return {
            ...request,
            item: KeySpace.withIndexKeys(request.item)
        };
    }
    return {
        ...request,
        key: KeySpace.keyOf(request.key)
    };
}), input, KeySpace.dkClient);
