import { convertObjectToUpdateExpression } from '../util/convertObjectToUpdateExpression';
import { updateTableItem } from './update';
export const updateQuickTableItem = async (Table, key, updateAttributes, input, dkClient = Table.dkClient) => {
    const updateExpressionParams = convertObjectToUpdateExpression(updateAttributes);
    const attributes = await updateTableItem(Table, key, {
        ...input,
        ...updateExpressionParams,
        expressionAttributeNames: {
            ...updateExpressionParams.expressionAttributeNames,
            ...input?.expressionAttributeNames
        },
        expressionAttributeValues: {
            ...updateExpressionParams.expressionAttributeValues,
            ...input?.expressionAttributeValues
        }
    }, dkClient);
    return attributes;
};
export const updateQuickItem = async (KeySpace, keyParams, updateAttributes, input) => {
    const attributes = await updateQuickTableItem(KeySpace.Table, KeySpace.keyOf(keyParams), updateAttributes, input, KeySpace.dkClient);
    const strippedAttributes = (attributes ? KeySpace.omitIndexKeys(attributes) : undefined);
    return strippedAttributes;
};
