import { createHash } from 'crypto';
export const zipObject = (keys, values) => {
    return Object.fromEntries(keys.map((k, i) => [k, values[i]]));
};
export const hash = (values, size = 21) => {
    const hash = createHash('sha256');
    for (const value of values) {
        hash.update(value);
    }
    const hashValue = hash.end().read();
    return hashValue.toString('base64url').split('-').join('').split('_').join('').slice(0, size) || '';
};
export const randomNumber = () => Math.round(Math.random() * Number.MAX_SAFE_INTEGER);
export const randomString = (size) => hash([randomNumber().toString()], size);
export const run = (fn) => fn();
export const arrayOfLength = (length) => Array.apply(null, Array(Math.max(Math.round(length), 0))).map(() => { });
