import { DynamoDBDocumentClient } from '@aws-sdk/lib-dynamodb';
import { DkCommand } from './command/Command';
import { Defaults } from './util/defaults';
import { DkMiddlewareHandler } from './Middleware';
import { ILogger } from './util/utils';
export interface DkClientConfig {
    client: DynamoDBDocumentClient;
    defaults: Defaults;
    middleware: Array<DkMiddlewareHandler>;
    logger?: ILogger;
}
export declare class DkClient implements DkClientConfig {
    client: DynamoDBDocumentClient;
    defaults: Defaults;
    middleware: Array<DkMiddlewareHandler>;
    logger?: ILogger;
    constructor(client: DynamoDBDocumentClient);
    setClient: (client?: DynamoDBDocumentClient) => void;
    setDefaults: (defaults?: Defaults) => void;
    setMiddleware: (middleware?: Array<DkMiddlewareHandler>) => void;
    setLogger: (logger?: ILogger) => void;
    send: <Command extends DkCommand<any, any, any, any, any, any, any, any>>(command: Command) => Promise<ReturnType<Command["send"]>>;
}
