export interface TestItem {
    string: string;
    number: number;
    updateableString?: string;
    list?: Array<string>;
    deep?: {
        deep: {
            deep: {
                string: string;
            };
        };
    };
    createdAt?: number;
    updatedAt?: number;
}
export declare const ManyGsiKeySpace: import("./KeySpace").KeySpace<import("./Table").Table<any, any, any, any, {
    client: import("@aws-sdk/lib-dynamodb").DynamoDBDocumentClient;
    name: string;
    indexes: {
        primaryIndex: {
            hash: {
                key: "pk";
                value: "string";
            };
            sort: {
                key: "sk";
                value: "string";
            };
        };
        gsi0: {
            hash: {
                key: "gsi0Pk";
                value: "string";
            };
            sort: {
                key: "gsi0Sk";
                value: "string";
            };
        };
        gsi1: {
            hash: {
                key: "gsi1Pk";
                value: "number";
            };
            sort: {
                key: "gsi1Sk";
                value: "number?";
            };
            projection: never[];
        };
        gsi2: {
            hash: {
                key: "gsi2Pk";
                value: "string";
            };
            sort: {
                key: "gsi2Sk";
                value: "number";
            };
            projection: "string"[];
        };
        gsi3: {
            hash: {
                key: "gsi3Pk";
                value: "number";
            };
            sort: {
                key: "gsi3Sk";
                value: "string?";
            };
        };
        gsi4: {
            hash: {
                key: "gsi4Pk";
                value: "string";
            };
        };
        gsi5: {
            hash: {
                key: "gsi5Pk";
                value: "number";
            };
        };
    };
}>, TestItem, "gsi0" | "gsi1" | "gsi2" | "gsi3" | "gsi4" | "gsi5", {
    primaryIndex: {
        pk: (params: Pick<TestItem, 'string'>) => string;
        sk: (params: Pick<TestItem, 'number'>) => string;
    };
    gsi0: {
        gsi0Pk: (params: Pick<TestItem, 'number'>) => string;
        gsi0Sk: (params: Pick<TestItem, 'string'>) => string;
    };
    gsi1: {
        gsi1Pk: (params: Pick<TestItem, 'number'>) => number;
        gsi1Sk: (params: Pick<TestItem, 'number'>) => number;
    };
    gsi2: {
        gsi2Pk: (params: Pick<TestItem, 'string'>) => string;
        gsi2Sk: (params: Pick<TestItem, 'number'>) => number;
    };
    gsi3: {
        gsi3Pk: (params: Pick<TestItem, 'number'>) => number;
        gsi3Sk: (params: Pick<TestItem, 'string'>) => string;
    };
    gsi4: {
        gsi4Pk: (params: Pick<TestItem, 'string'>) => string;
    };
    gsi5: {
        gsi5Pk: (params: Pick<TestItem, 'number'>) => number;
    };
}>;
export declare const NoGsiKeySpace: import("./KeySpace").KeySpace<import("./Table").Table<any, any, any, any, {
    client: import("@aws-sdk/lib-dynamodb").DynamoDBDocumentClient;
    name: string;
    indexes: {
        primaryIndex: {
            hash: {
                key: "pk";
                value: "string";
            };
            sort: {
                key: "sk";
                value: "string";
            };
        };
        gsi0: {
            hash: {
                key: "gsi0Pk";
                value: "string";
            };
            sort: {
                key: "gsi0Sk";
                value: "string";
            };
        };
        gsi1: {
            hash: {
                key: "gsi1Pk";
                value: "number";
            };
            sort: {
                key: "gsi1Sk";
                value: "number?";
            };
            projection: never[];
        };
        gsi2: {
            hash: {
                key: "gsi2Pk";
                value: "string";
            };
            sort: {
                key: "gsi2Sk";
                value: "number";
            };
            projection: "string"[];
        };
        gsi3: {
            hash: {
                key: "gsi3Pk";
                value: "number";
            };
            sort: {
                key: "gsi3Sk";
                value: "string?";
            };
        };
        gsi4: {
            hash: {
                key: "gsi4Pk";
                value: "string";
            };
        };
        gsi5: {
            hash: {
                key: "gsi5Pk";
                value: "number";
            };
        };
    };
}>, TestItem, never, {
    primaryIndex: {
        pk: (params: Pick<TestItem, 'string'>) => string;
        sk: (params: Pick<TestItem, 'number'>) => string;
    };
}>;
export declare const NoGsiNeverParamKeySpace: import("./KeySpace").KeySpace<import("./Table").Table<any, any, any, any, {
    client: import("@aws-sdk/lib-dynamodb").DynamoDBDocumentClient;
    name: string;
    indexes: {
        primaryIndex: {
            hash: {
                key: "pk";
                value: "string";
            };
            sort: {
                key: "sk";
                value: "string";
            };
        };
        gsi0: {
            hash: {
                key: "gsi0Pk";
                value: "string";
            };
            sort: {
                key: "gsi0Sk";
                value: "string";
            };
        };
        gsi1: {
            hash: {
                key: "gsi1Pk";
                value: "number";
            };
            sort: {
                key: "gsi1Sk";
                value: "number?";
            };
            projection: never[];
        };
        gsi2: {
            hash: {
                key: "gsi2Pk";
                value: "string";
            };
            sort: {
                key: "gsi2Sk";
                value: "number";
            };
            projection: "string"[];
        };
        gsi3: {
            hash: {
                key: "gsi3Pk";
                value: "number";
            };
            sort: {
                key: "gsi3Sk";
                value: "string?";
            };
        };
        gsi4: {
            hash: {
                key: "gsi4Pk";
                value: "string";
            };
        };
        gsi5: {
            hash: {
                key: "gsi5Pk";
                value: "number";
            };
        };
    };
}>, TestItem, never, {
    primaryIndex: {
        pk: () => string;
        sk: (params: Pick<TestItem, 'string'>) => string;
    };
}>;
export declare const NoGsiNeverParamsKeySpace: import("./KeySpace").KeySpace<import("./Table").Table<any, any, any, any, {
    client: import("@aws-sdk/lib-dynamodb").DynamoDBDocumentClient;
    name: string;
    indexes: {
        primaryIndex: {
            hash: {
                key: "pk";
                value: "string";
            };
            sort: {
                key: "sk";
                value: "string";
            };
        };
        gsi0: {
            hash: {
                key: "gsi0Pk";
                value: "string";
            };
            sort: {
                key: "gsi0Sk";
                value: "string";
            };
        };
        gsi1: {
            hash: {
                key: "gsi1Pk";
                value: "number";
            };
            sort: {
                key: "gsi1Sk";
                value: "number?";
            };
            projection: never[];
        };
        gsi2: {
            hash: {
                key: "gsi2Pk";
                value: "string";
            };
            sort: {
                key: "gsi2Sk";
                value: "number";
            };
            projection: "string"[];
        };
        gsi3: {
            hash: {
                key: "gsi3Pk";
                value: "number";
            };
            sort: {
                key: "gsi3Sk";
                value: "string?";
            };
        };
        gsi4: {
            hash: {
                key: "gsi4Pk";
                value: "string";
            };
        };
        gsi5: {
            hash: {
                key: "gsi5Pk";
                value: "number";
            };
        };
    };
}>, TestItem, never, {
    primaryIndex: {
        pk: () => string;
        sk: () => string;
    };
}>;
