import { ConsumedCapacity, ItemCollectionMetrics } from '@aws-sdk/client-dynamodb';
import { DkCommandGenericData, DkCommandMiddlewareData } from './command/Command';
export type DkMiddlewareHandlerDataType<DataType extends string, Data> = {
    dataType: DataType;
    data: Data;
};
export type DkMiddlewareConfigType<DataType extends string, Hook extends string, Data> = {
    hook: Hook;
    handlerData: DkMiddlewareHandlerDataType<DataType, Data>;
};
export type DkMiddlewareConfig<Data extends DkCommandGenericData = DkCommandGenericData> = DkCommandMiddlewareData<Data> | DkMiddlewareConfigType<'ConsumedCapacity', 'ConsumedCapacity', ConsumedCapacity> | DkMiddlewareConfigType<'ItemCollectionMetrics', 'ItemCollectionMetrics', ItemCollectionMetrics>;
export type DkMiddlewareHook = DkMiddlewareConfig['hook'];
export type DkMiddlewareDataType = DkMiddlewareConfig['handlerData']['dataType'];
export type GetDkMiddlewareConfig<Hook extends DkMiddlewareHook = DkMiddlewareHook, Data extends DkCommandGenericData = DkCommandGenericData> = Extract<DkMiddlewareConfig<Data>, {
    hook: Hook;
}>;
export type DkMiddlewareHandler<Hook extends DkMiddlewareHook = DkMiddlewareHook, Data extends DkCommandGenericData = DkCommandGenericData> = {
    hook: Hook;
    handler: (params: GetDkMiddlewareConfig<Hook, Data>['handlerData']) => GetDkMiddlewareConfig<Hook, Data>['handlerData']['data'] | Promise<GetDkMiddlewareConfig<Hook, Data>['handlerData']['data']> | undefined;
};
export declare const executeMiddleware: <Hook extends "ConsumedCapacity" | "ItemCollectionMetrics" | "BatchGetCommandInput" | "CommandInput" | "ReadCommandInput" | "BatchGetCommandOutput" | "CommandOutput" | "ReadCommandOutput" | "BatchWriteCommandInput" | "WriteCommandInput" | "BatchWriteCommandOutput" | "WriteCommandOutput" | "DeleteCommandInput" | "DeleteCommandOutput" | "GetCommandInput" | "GetCommandOutput" | "PutCommandInput" | "PutCommandOutput" | "QueryCommandInput" | "QueryCommandOutput" | "ScanCommandInput" | "ScanCommandOutput" | "TransactGetCommandInput" | "TransactGetCommandOutput" | "TransactWriteCommandInput" | "TransactWriteCommandOutput" | "UpdateCommandInput" | "UpdateCommandOutput", Params extends GetDkMiddlewareConfig<Hook, DkCommandGenericData>["handlerData"]>(hook: Hook, params: Params, middleware: Array<DkMiddlewareHandler>) => Promise<Params>;
export declare const executeMiddlewares: <Hook extends "ConsumedCapacity" | "ItemCollectionMetrics" | "BatchGetCommandInput" | "CommandInput" | "ReadCommandInput" | "BatchGetCommandOutput" | "CommandOutput" | "ReadCommandOutput" | "BatchWriteCommandInput" | "WriteCommandInput" | "BatchWriteCommandOutput" | "WriteCommandOutput" | "DeleteCommandInput" | "DeleteCommandOutput" | "GetCommandInput" | "GetCommandOutput" | "PutCommandInput" | "PutCommandOutput" | "QueryCommandInput" | "QueryCommandOutput" | "ScanCommandInput" | "ScanCommandOutput" | "TransactGetCommandInput" | "TransactGetCommandOutput" | "TransactWriteCommandInput" | "TransactWriteCommandOutput" | "UpdateCommandInput" | "UpdateCommandOutput", Params extends GetDkMiddlewareConfig<Hook, DkCommandGenericData>["handlerData"]>(hooks: Hook[], params: Params, middleware: Array<DkMiddlewareHandler>) => Promise<Params>;
export declare const appendMiddleware: (middlewares1: Array<DkMiddlewareHandler<DkMiddlewareHook, any>>, middlewares2: Array<DkMiddlewareHandler<DkMiddlewareHook, any>>) => DkMiddlewareHandler<"ConsumedCapacity" | "ItemCollectionMetrics" | "BatchGetCommandInput" | "CommandInput" | "ReadCommandInput" | "BatchGetCommandOutput" | "CommandOutput" | "ReadCommandOutput" | "BatchWriteCommandInput" | "WriteCommandInput" | "BatchWriteCommandOutput" | "WriteCommandOutput" | "DeleteCommandInput" | "DeleteCommandOutput" | "GetCommandInput" | "GetCommandOutput" | "PutCommandInput" | "PutCommandOutput" | "QueryCommandInput" | "QueryCommandOutput" | "ScanCommandInput" | "ScanCommandOutput" | "TransactGetCommandInput" | "TransactGetCommandOutput" | "TransactWriteCommandInput" | "TransactWriteCommandOutput" | "UpdateCommandInput" | "UpdateCommandOutput", any>[];
