import { DynamoDB } from '@aws-sdk/client-dynamodb';
import { DynamoDBDocumentClient } from '@aws-sdk/lib-dynamodb';
import { Table } from './Table';
export declare const TABLE_NAME: string;
export declare const Client: DynamoDB;
export declare const DocumentClient: DynamoDBDocumentClient;
export declare const NoGsiTable: Table<any, any, any, any, {
    client: DynamoDBDocumentClient;
    name: string;
    indexes: {
        primaryIndex: {
            hash: {
                key: "pk";
                value: "string";
            };
            sort: {
                key: "sk";
                value: "string";
            };
        };
    };
}>;
export declare const ManyGsiTable: Table<any, any, any, any, {
    client: DynamoDBDocumentClient;
    name: string;
    indexes: {
        primaryIndex: {
            hash: {
                key: "pk";
                value: "string";
            };
            sort: {
                key: "sk";
                value: "string";
            };
        };
        gsi0: {
            hash: {
                key: "gsi0Pk";
                value: "string";
            };
            sort: {
                key: "gsi0Sk";
                value: "string";
            };
        };
        gsi1: {
            hash: {
                key: "gsi1Pk";
                value: "number";
            };
            sort: {
                key: "gsi1Sk";
                value: "number?";
            };
            projection: never[];
        };
        gsi2: {
            hash: {
                key: "gsi2Pk";
                value: "string";
            };
            sort: {
                key: "gsi2Sk";
                value: "number";
            };
            projection: "string"[];
        };
        gsi3: {
            hash: {
                key: "gsi3Pk";
                value: "number";
            };
            sort: {
                key: "gsi3Sk";
                value: "string?";
            };
        };
        gsi4: {
            hash: {
                key: "gsi4Pk";
                value: "string";
            };
        };
        gsi5: {
            hash: {
                key: "gsi5Pk";
                value: "number";
            };
        };
    };
}>;
