import { TransactGetCommandInput, TransactGetCommandOutput } from '@aws-sdk/lib-dynamodb';
import { DkCommand } from './Command';
import { GenericAttributes } from '../util/utils';
import { LowerCaseObjectKeys } from '../util/keyCapitalize';
import { DkClientConfig } from '../Client';
import { Get } from '@aws-sdk/client-dynamodb';
declare const TRANSACT_GET_COMMAND_INPUT_DATA_TYPE: "TransactGetCommandInput";
declare const TRANSACT_GET_COMMAND_INPUT_HOOK: readonly ["CommandInput", "ReadCommandInput", "TransactGetCommandInput"];
declare const TRANSACT_GET_COMMAND_OUTPUT_DATA_TYPE: "TransactGetCommandOutput";
declare const TRANSACT_GET_COMMAND_OUTPUT_HOOK: readonly ["CommandOutput", "ReadCommandOutput", "TransactGetCommandOutput"];
export interface DkTransactGetCommandInput<Key extends GenericAttributes = GenericAttributes> extends LowerCaseObjectKeys<Omit<TransactGetCommandInput, 'TransactItems'>> {
    requests: (LowerCaseObjectKeys<Omit<Get, 'Key'>> & {
        key: Key;
    })[];
}
export interface DkTransactGetCommandOutput<Attributes extends GenericAttributes = GenericAttributes> extends LowerCaseObjectKeys<Omit<TransactGetCommandOutput, 'Responses'>> {
    items: Array<Attributes>;
}
export declare class DkTransactGetCommand<Attributes extends GenericAttributes = GenericAttributes, Key extends GenericAttributes = GenericAttributes> extends DkCommand<typeof TRANSACT_GET_COMMAND_INPUT_DATA_TYPE, (typeof TRANSACT_GET_COMMAND_INPUT_HOOK)[number], DkTransactGetCommandInput<Key>, TransactGetCommandInput, typeof TRANSACT_GET_COMMAND_OUTPUT_DATA_TYPE, (typeof TRANSACT_GET_COMMAND_OUTPUT_HOOK)[number], DkTransactGetCommandOutput<Attributes>, TransactGetCommandOutput> {
    constructor(input: DkTransactGetCommandInput<Key>);
    inputMiddlewareConfig: {
        dataType: "TransactGetCommandInput";
        hooks: readonly ["CommandInput", "ReadCommandInput", "TransactGetCommandInput"];
    };
    outputMiddlewareConfig: {
        dataType: "TransactGetCommandOutput";
        hooks: readonly ["CommandOutput", "ReadCommandOutput", "TransactGetCommandOutput"];
    };
    handleInput: ({ defaults, middleware }: DkClientConfig) => Promise<TransactGetCommandInput>;
    handleOutput: (output: TransactGetCommandOutput, { middleware }: DkClientConfig) => Promise<DkTransactGetCommandOutput<Attributes>>;
    send: (clientConfig: DkClientConfig) => Promise<DkTransactGetCommandOutput<Attributes>>;
}
export {};
