import { UpdateCommandInput, UpdateCommandOutput } from '@aws-sdk/lib-dynamodb';
import { DkCommand } from './Command';
import { ReturnValue } from '@aws-sdk/client-dynamodb';
import { GenericAttributes } from '../util/utils';
import { ReturnValuesAttributes } from '../util/returnValuesAttributes';
import { LowerCaseObjectKeys } from '../util/keyCapitalize';
import { DkClientConfig } from '../Client';
declare const UPDATE_COMMAND_INPUT_DATA_TYPE: "UpdateCommandInput";
declare const UPDATE_COMMAND_INPUT_HOOK: readonly ["CommandInput", "WriteCommandInput", "UpdateCommandInput"];
declare const UPDATE_COMMAND_OUTPUT_DATA_TYPE: "UpdateCommandOutput";
declare const UPDATE_COMMAND_OUTPUT_HOOK: readonly ["CommandOutput", "WriteCommandOutput", "UpdateCommandOutput"];
export type DkUpdateReturnValues = ReturnValue | undefined;
export interface DkUpdateCommandInput<Key extends GenericAttributes = GenericAttributes, ReturnValues extends DkUpdateReturnValues = DkUpdateReturnValues> extends LowerCaseObjectKeys<Omit<UpdateCommandInput, 'Key' | 'ReturnValues' | 'AttributeUpdates' | 'Expected' | 'ConditionalOperator'>> {
    key: Key;
    returnValues?: ReturnValues;
}
export interface DkUpdateCommandOutput<Attributes extends GenericAttributes = GenericAttributes, ReturnValues extends DkUpdateReturnValues = DkUpdateReturnValues> extends LowerCaseObjectKeys<Omit<UpdateCommandOutput, 'Attributes'>> {
    attributes: ReturnValuesAttributes<Attributes, ReturnValues>;
}
export declare class DkUpdateCommand<Attributes extends GenericAttributes = GenericAttributes, Key extends GenericAttributes = GenericAttributes, ReturnValues extends DkUpdateReturnValues = DkUpdateReturnValues> extends DkCommand<typeof UPDATE_COMMAND_INPUT_DATA_TYPE, (typeof UPDATE_COMMAND_INPUT_HOOK)[number], DkUpdateCommandInput<Key, ReturnValues>, UpdateCommandInput, typeof UPDATE_COMMAND_OUTPUT_DATA_TYPE, (typeof UPDATE_COMMAND_OUTPUT_HOOK)[number], DkUpdateCommandOutput<Attributes, ReturnValues>, UpdateCommandOutput> {
    constructor(input: DkUpdateCommandInput<Key, ReturnValues>);
    inputMiddlewareConfig: {
        dataType: "UpdateCommandInput";
        hooks: readonly ["CommandInput", "WriteCommandInput", "UpdateCommandInput"];
    };
    outputMiddlewareConfig: {
        dataType: "UpdateCommandOutput";
        hooks: readonly ["CommandOutput", "WriteCommandOutput", "UpdateCommandOutput"];
    };
    handleInput: ({ defaults, middleware }: DkClientConfig) => Promise<UpdateCommandInput>;
    handleOutput: (output: UpdateCommandOutput, { middleware }: DkClientConfig) => Promise<DkUpdateCommandOutput<Attributes, ReturnValues>>;
    send: (clientConfig: DkClientConfig) => Promise<DkUpdateCommandOutput<Attributes, ReturnValues>>;
}
export {};
