import { KeySpace } from '../KeySpace';
import { GenericAttributes } from '../util/utils';
import { Table } from '../Table';
import { DkBatchWriteCommandInput, DkBatchWriteCommandOutput } from '../command/BatchWrite';
import { DkClient } from '../Client';
export interface BatchWriteItemsInput extends Omit<DkBatchWriteCommandInput, 'requests'> {
    pageLimit?: number;
}
export interface BatchWriteItemsOutput<Attributes extends GenericAttributes = GenericAttributes, Key extends GenericAttributes = GenericAttributes> extends Partial<Omit<DkBatchWriteCommandOutput, 'unprocessedRequests'>> {
    unprocessedRequests: NonNullable<DkBatchWriteCommandOutput<Attributes, Key>['unprocessedRequests']>[string];
}
export declare const batchWriteTableItems: <T extends Table<any, any, any, any, import("../Table").TableConfig<any, any, any, any>> = Table<any, any, any, any, import("../Table").TableConfig<any, any, any, any>>>(Table: T, requests: ({
    put: import("../util/utils").Remap<T["secondaryIndexes"][number] extends string ? Table.GetIndexKeyMap<T>[T["primaryIndex"]] & Partial<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[T["secondaryIndexes"][number]]>> : Table.GetIndexKeyMap<T>[T["primaryIndex"]]>;
} | {
    delete: import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<T["primaryIndex"], undefined>]>>;
})[], input?: BatchWriteItemsInput, dkClient?: DkClient) => Promise<BatchWriteItemsOutput<import("../util/utils").Remap<T["secondaryIndexes"][number] extends string ? Table.GetIndexKeyMap<T>[T["primaryIndex"]] & Partial<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[T["secondaryIndexes"][number]]>> : Table.GetIndexKeyMap<T>[T["primaryIndex"]]>, import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<T["primaryIndex"], undefined>]>>>>;
export declare const batchWriteItems: <K extends KeySpace<any, GenericAttributes, any, any> = KeySpace<any, GenericAttributes, any, any>>(KeySpace: K, requests: ({
    put: KeySpace.GetAttributes<K>;
} | {
    delete: KeySpace.GetIndexKeyValueParams<K, K["primaryIndex"]>;
})[], input?: BatchWriteItemsInput) => Promise<BatchWriteItemsOutput<KeySpace.GetAttributesAndKeys<K>, import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<KeySpace.GetIndexKeyMap<K>[K["primaryIndex"]]>>>>;
