import { Table } from '../Table';
import { KeySpace } from '../KeySpace';
import { GenericAttributes } from '../util/utils';
import { DkQueryCommandInput, DkQueryCommandOutput } from '../command/Query';
import { DkClient } from '../Client';
export interface ListParams<Index extends string | never | undefined> {
    index?: Index;
    pageLimit?: number;
    totalLimit?: number;
    autoPage?: boolean;
}
export interface QueryItemsInput<Index extends string | never | undefined = undefined, CursorKey extends GenericAttributes = GenericAttributes> extends Omit<DkQueryCommandInput<CursorKey>, 'tableName' | 'index' | 'limit'>, ListParams<Index> {
}
export type QueryItemsOutput<Attributes extends GenericAttributes = GenericAttributes, CursorKey extends GenericAttributes = GenericAttributes> = DkQueryCommandOutput<Attributes, CursorKey>;
export declare const queryTableItems: <T extends Table<any, any, any, any, import("../Table").TableConfig<any, any, any, any>> = Table<any, any, any, any, import("../Table").TableConfig<any, any, any, any>>, Index extends T["secondaryIndexes"][number] | undefined = undefined>(Table: T, input: QueryItemsInput<Index, import("../util/utils").Remap<import("ts-toolbelt/out/Any/Cast").Cast<import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<Index & string, undefined> | Exclude<T["primaryIndex"], undefined>]>>, import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<T["primaryIndex"], undefined>]>>>>>, dkClient?: DkClient) => Promise<QueryItemsOutput<import("../util/utils").Remap<T["secondaryIndexes"][number] extends string ? Table.GetIndexKeyMap<T>[T["primaryIndex"]] & Partial<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[T["secondaryIndexes"][number]]>> : Table.GetIndexKeyMap<T>[T["primaryIndex"]]>, import("../util/utils").Remap<import("ts-toolbelt/out/Any/Cast").Cast<import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<Index & string, undefined> | Exclude<T["primaryIndex"], undefined>]>>, import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<T["primaryIndex"], undefined>]>>>>>>;
export declare const queryItems: <K extends KeySpace<any, GenericAttributes, any, any> = KeySpace<any, GenericAttributes, any, any>, Index extends K["secondaryIndexes"][number] | undefined = undefined>(KeySpace: K, input: QueryItemsInput<Index, import("../util/utils").Remap<import("ts-toolbelt/out/Any/Cast").Cast<import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<K["Table"]>[Exclude<Index, undefined> | Exclude<K["Table"]["primaryIndex"], undefined>]>>, import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<K["Table"]>[Exclude<K["Table"]["primaryIndex"], undefined>]>>>>>) => Promise<QueryItemsOutput<KeySpace.GetAttributes<K>, import("../util/utils").Remap<import("ts-toolbelt/out/Any/Cast").Cast<import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<K["Table"]>[Exclude<Index, undefined> | Exclude<K["Table"]["primaryIndex"], undefined>]>>, import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<K["Table"]>[Exclude<K["Table"]["primaryIndex"], undefined>]>>>>>>;
