import { O } from 'ts-toolbelt';
type RequiredObjectPart<T extends object> = Pick<T, O.RequiredKeys<T>>;
type OptionalObjectPart<T extends object> = Pick<T, O.OptionalKeys<T>>;
export type LowerCaseObjectKeys<T extends object> = {
    [key in LowerCaseKeys<OptionalObjectPart<T>>]?: Capitalize<key> extends keyof T ? T[Capitalize<key>] : never;
} & {
    [key in LowerCaseKeys<RequiredObjectPart<T>>]: Capitalize<key> extends keyof T ? T[Capitalize<key>] : never;
};
type LowerCaseKeys<T extends object> = Uncapitalize<keyof T & string>;
export declare const lowerCaseKeys: <T extends object>(obj: T) => LowerCaseObjectKeys<T>;
export type UpperCaseObjectKeys<T extends object> = {
    [key in UpperCaseKeys<OptionalObjectPart<T>>]?: Uncapitalize<key> extends keyof T ? T[Uncapitalize<key>] : never;
} & {
    [key in UpperCaseKeys<RequiredObjectPart<T>>]: Uncapitalize<key> extends keyof T ? T[Uncapitalize<key>] : never;
};
type UpperCaseKeys<T extends object> = Capitalize<keyof T & string>;
export declare const upperCaseKeys: <T extends object>(obj: T) => UpperCaseObjectKeys<T>;
export {};
