import { Table } from '../Table';
import { KeySpace } from '../KeySpace';
import { QueryItemsInput, QueryItemsOutput } from './query';
import { DkQuickQueryOperators } from '../util/createSortKeyQuery';
import { GenericAttributes } from '../util/utils';
import { DkClient } from '../Client';
export type QueryQuickItemsInput<Index extends string | never | undefined = never | undefined, CursorKey extends GenericAttributes = GenericAttributes, HashKeyParams extends any = any> = Omit<QueryItemsInput<Index, CursorKey>, 'keyConditionExpression'> & DkQuickQueryOperators & {
    hashKeyParams: HashKeyParams;
};
export type QueryQuickItemsOutput<Attributes extends GenericAttributes = GenericAttributes, CursorKey extends GenericAttributes = GenericAttributes> = QueryItemsOutput<Attributes, CursorKey>;
export declare const queryQuickTableItems: <T extends Table<any, any, any, any, import("../Table").TableConfig<any, any, any, any>> = Table<any, any, any, any, import("../Table").TableConfig<any, any, any, any>>, Index extends T["secondaryIndexes"][number] | undefined = undefined>(Table: T, input: QueryQuickItemsInput<Index & string, import("../util/utils").Remap<import("ts-toolbelt/out/Any/Cast").Cast<import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<Index & string, undefined> | Exclude<T["primaryIndex"], undefined>]>>, import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<T["primaryIndex"], undefined>]>>>>, Index extends T["secondaryIndexes"][number] ? import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<Index, undefined>]>>[T["config"]["indexes"][Index]["hash"]["key"]] : import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<T["primaryIndex"], undefined>]>>[T["config"]["indexes"][T["primaryIndex"]]["hash"]["key"]]>, dkClient?: DkClient) => Promise<QueryQuickItemsOutput<import("../util/utils").Remap<T["secondaryIndexes"][number] extends string ? Table.GetIndexKeyMap<T>[T["primaryIndex"]] & Partial<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[T["secondaryIndexes"][number]]>> : Table.GetIndexKeyMap<T>[T["primaryIndex"]]>, import("../util/utils").Remap<import("ts-toolbelt/out/Any/Cast").Cast<import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<Index & string, undefined> | Exclude<T["primaryIndex"], undefined>]>>, import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<T>[Exclude<T["primaryIndex"], undefined>]>>>>>>;
export declare const queryQuickItems: <K extends KeySpace<any, GenericAttributes, any, any> = KeySpace<any, GenericAttributes, any, any>, Index extends K["secondaryIndexes"][number] | undefined = undefined>(KeySpace: K, input: QueryQuickItemsInput<Index, import("../util/utils").Remap<import("ts-toolbelt/out/Any/Cast").Cast<import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<K["Table"]>[Exclude<Index, undefined> | Exclude<K["Table"]["primaryIndex"], undefined>]>>, import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<K["Table"]>[Exclude<K["Table"]["primaryIndex"], undefined>]>>>>, Index extends K["secondaryIndexes"][number] ? KeySpace.GetIndexHashKeyValueParamsMap<K>[Index] : KeySpace.GetIndexHashKeyValueParamsMap<K>[K["primaryIndex"]]>) => Promise<QueryQuickItemsOutput<KeySpace.GetAttributes<K>, import("../util/utils").Remap<import("ts-toolbelt/out/Any/Cast").Cast<import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<K["Table"]>[Exclude<Index, undefined> | Exclude<K["Table"]["primaryIndex"], undefined>]>>, import("../util/utils").Remap<import("ts-toolbelt/out/Union/IntersectOf").IntersectOf<Table.GetIndexKeyMap<K["Table"]>[Exclude<K["Table"]["primaryIndex"], undefined>]>>>>>>;
